Index: /pkpgcounter/trunk/pdlanalyzer/pdf.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/pdf.py (revision 191)
+++ /pkpgcounter/trunk/pdlanalyzer/pdf.py (revision 191)
@@ -0,0 +1,20 @@
+#
+# pkpgcounter : a generic Page Description Language parser
+#
+# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+#
+# $Id$
+#
Index: /pkpgcounter/trunk/pdlanalyzer/pcl345.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/pcl345.py (revision 191)
+++ /pkpgcounter/trunk/pdlanalyzer/pcl345.py (revision 191)
@@ -0,0 +1,20 @@
+#
+# pkpgcounter : a generic Page Description Language parser
+#
+# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+#
+# $Id$
+#
Index: /pkpgcounter/trunk/pdlanalyzer/postscript.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/postscript.py (revision 191)
+++ /pkpgcounter/trunk/pdlanalyzer/postscript.py (revision 191)
@@ -0,0 +1,20 @@
+#
+# pkpgcounter : a generic Page Description Language parser
+#
+# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+#
+# $Id$
+#
Index: /pkpgcounter/trunk/pdlanalyzer/escp2.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/escp2.py (revision 191)
+++ /pkpgcounter/trunk/pdlanalyzer/escp2.py (revision 191)
@@ -0,0 +1,20 @@
+#
+# pkpgcounter : a generic Page Description Language parser
+#
+# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+#
+# $Id$
+#
Index: /pkpgcounter/trunk/pdlanalyzer/pclxl.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/pclxl.py (revision 191)
+++ /pkpgcounter/trunk/pdlanalyzer/pclxl.py (revision 191)
@@ -0,0 +1,20 @@
+#
+# pkpgcounter : a generic Page Description Language parser
+#
+# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+#
+# $Id$
+#