Index: pkpgcounter/trunk/pdlanalyzer/pdf.py
===================================================================
--- pkpgcounter/trunk/pdlanalyzer/pdf.py (revision 193)
+++ pkpgcounter/trunk/pdlanalyzer/pdf.py (revision 196)
@@ -25,5 +25,5 @@
 import re
 
-from pdlanalyzer.pdlparser import PDLParser
+from pdlanalyzer.pdlparser import PDLParser, PDLParserError
 
 class PDFParser(PDLParser) :
@@ -39,5 +39,23 @@
 def test() :        
     """Test function."""
-    raise RuntimeError, "Not implemented !"
+    if (len(sys.argv) < 2) or ((not sys.stdin.isatty()) and ("-" not in sys.argv[1:])) :
+        sys.argv.append("-")
+    totalsize = 0    
+    for arg in sys.argv[1:] :
+        if arg == "-" :
+            infile = sys.stdin
+            mustclose = 0
+        else :    
+            infile = open(arg, "rb")
+            mustclose = 1
+        try :
+            parser = PDFParser(infile, debug=1)
+            totalsize += parser.getJobSize()
+        except PDLParserError, msg :    
+            sys.stderr.write("ERROR: %s\n" % msg)
+            sys.stderr.flush()
+        if mustclose :    
+            infile.close()
+    print "%s" % totalsize
     
 if __name__ == "__main__" :    
Index: pkpgcounter/trunk/pdlanalyzer/pcl345.py
===================================================================
--- pkpgcounter/trunk/pdlanalyzer/pcl345.py (revision 193)
+++ pkpgcounter/trunk/pdlanalyzer/pcl345.py (revision 196)
@@ -25,5 +25,5 @@
 import mmap
 
-from pdlanalyzer.pdlparser import PDLParser
+from pdlanalyzer.pdlparser import PDLParser, PDLParserError
 
 class PCLParser(PDLParser) :
@@ -332,5 +332,23 @@
 def test() :        
     """Test function."""
-    raise RuntimeError, "Not implemented !"
+    if (len(sys.argv) < 2) or ((not sys.stdin.isatty()) and ("-" not in sys.argv[1:])) :
+        sys.argv.append("-")
+    totalsize = 0    
+    for arg in sys.argv[1:] :
+        if arg == "-" :
+            infile = sys.stdin
+            mustclose = 0
+        else :    
+            infile = open(arg, "rb")
+            mustclose = 1
+        try :
+            parser = PCL345Parser(infile, debug=1)
+            totalsize += parser.getJobSize()
+        except PDLParserError, msg :    
+            sys.stderr.write("ERROR: %s\n" % msg)
+            sys.stderr.flush()
+        if mustclose :    
+            infile.close()
+    print "%s" % totalsize
     
 if __name__ == "__main__" :    
Index: pkpgcounter/trunk/pdlanalyzer/postscript.py
===================================================================
--- pkpgcounter/trunk/pdlanalyzer/postscript.py (revision 193)
+++ pkpgcounter/trunk/pdlanalyzer/postscript.py (revision 196)
@@ -100,5 +100,23 @@
 def test() :        
     """Test function."""
-    raise RuntimeError, "Not implemented !"
+    if (len(sys.argv) < 2) or ((not sys.stdin.isatty()) and ("-" not in sys.argv[1:])) :
+        sys.argv.append("-")
+    totalsize = 0    
+    for arg in sys.argv[1:] :
+        if arg == "-" :
+            infile = sys.stdin
+            mustclose = 0
+        else :    
+            infile = open(arg, "rb")
+            mustclose = 1
+        try :
+            parser = PostScriptParser(infile, debug=1)
+            totalsize += parser.getJobSize()
+        except PDLParserError, msg :    
+            sys.stderr.write("ERROR: %s\n" % msg)
+            sys.stderr.flush()
+        if mustclose :    
+            infile.close()
+    print "%s" % totalsize
     
 if __name__ == "__main__" :    
Index: pkpgcounter/trunk/pdlanalyzer/escp2.py
===================================================================
--- pkpgcounter/trunk/pdlanalyzer/escp2.py (revision 193)
+++ pkpgcounter/trunk/pdlanalyzer/escp2.py (revision 196)
@@ -24,5 +24,5 @@
 import sys
 
-from pdlanalyzer.pdlparser import PDLParser
+from pdlanalyzer.pdlparser import PDLParser, PDLParserError
 
 class ESCP2Parser(PDLParser) :
@@ -65,5 +65,23 @@
 def test() :        
     """Test function."""
-    raise RuntimeError, "Not implemented !"
+    if (len(sys.argv) < 2) or ((not sys.stdin.isatty()) and ("-" not in sys.argv[1:])) :
+        sys.argv.append("-")
+    totalsize = 0    
+    for arg in sys.argv[1:] :
+        if arg == "-" :
+            infile = sys.stdin
+            mustclose = 0
+        else :    
+            infile = open(arg, "rb")
+            mustclose = 1
+        try :
+            parser = ESCP2Parser(infile, debug=1)
+            totalsize += parser.getJobSize()
+        except PDLParserError, msg :    
+            sys.stderr.write("ERROR: %s\n" % msg)
+            sys.stderr.flush()
+        if mustclose :    
+            infile.close()
+    print "%s" % totalsize
     
 if __name__ == "__main__" :    
Index: pkpgcounter/trunk/pdlanalyzer/pclxl.py
===================================================================
--- pkpgcounter/trunk/pdlanalyzer/pclxl.py (revision 193)
+++ pkpgcounter/trunk/pdlanalyzer/pclxl.py (revision 196)
@@ -332,5 +332,23 @@
 def test() :        
     """Test function."""
-    raise RuntimeError, "Not implemented !"
+    if (len(sys.argv) < 2) or ((not sys.stdin.isatty()) and ("-" not in sys.argv[1:])) :
+        sys.argv.append("-")
+    totalsize = 0    
+    for arg in sys.argv[1:] :
+        if arg == "-" :
+            infile = sys.stdin
+            mustclose = 0
+        else :    
+            infile = open(arg, "rb")
+            mustclose = 1
+        try :
+            parser = PCLXLParser(infile, debug=1)
+            totalsize += parser.getJobSize()
+        except PDLParserError, msg :    
+            sys.stderr.write("ERROR: %s\n" % msg)
+            sys.stderr.flush()
+        if mustclose :    
+            infile.close()
+    print "%s" % totalsize
     
 if __name__ == "__main__" :    