Index: pkpgcounter/trunk/tests/README
===================================================================
--- pkpgcounter/trunk/tests/README (revision 197)
+++ pkpgcounter/trunk/tests/README (revision 197)
@@ -0,0 +1,36 @@
+# $Id$
+
+pkpgcounter : a generic Page Description Language parser
+
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+
+====================================================================
+
+This directory contains a gzipped PostScript file, master.ps.gz, 
+obtained by printing to a file a part of the SlashDot.org website 
+from the Galeon web browser on July 2nd 2004. 
+
+When uncompressed, this 16 pages file can be used to test the 
+accuracy of the generic Page Description Language analyzer included 
+in pkpgcounter for different conversion outputs of gs. 
+
+To see if it works, simply launch :
+
+        $ ./runtests.sh
+        
+It should report 16 pages for each document. If it doesn't then 
+there's a bug in the generic Page Description Language analyzer. 
+Please report this to : alet@librelogiciel.com
Index: pkpgcounter/trunk/tests/runtest.sh
===================================================================
--- pkpgcounter/trunk/tests/runtest.sh (revision 197)
+++ pkpgcounter/trunk/tests/runtest.sh (revision 197)
@@ -0,0 +1,18 @@
+#! /bin/sh
+
+echo -n "Generating testsuite..."
+gunzip <master.ps.gz >master2.ps
+for device in lj250 lj4dithp ljet2p ljet4pjl ljetplus laserjet ljet3 ljet4 lj5gray lj5mono pxlmono pxlcolor pdfwrite pswrite psgray psmono psrgb epson epsonc eps9mid eps9high stcolor st800 escp escpc pcl3 cdeskjet cdj1600 cdj500 cdj550 cdj670 cdj850 cdj880 cdj890 cdj970 cdjcolor cdjmono dj505j djet500 djet500c hpdj1120c hpdj310 hpdj320 hpdj340 hpdj400 hpdj500 hpdj500c hpdj510 hpdj520 hpdj540 hpdj550c hpdj560c hpdj600 hpdj660c hpdj670c hpdj680c hpdj690c hpdj850c hpdj855c hpdj870c hpdj890c hpdjplus hpdjportable ; do
+    if ! [ -f "testsuite.$device" ]  ; then
+        gs -dQUIET -dBATCH -dNOPAUSE -sOutputFile="testsuite.$device" -sDEVICE="$device" master2.ps ; 
+    fi ;
+    done
+echo 
+
+echo -n "File master.ps should be 16 pages long, result is : "
+python ../pdlanalyzer/pdlanalyzer.py master2.ps
+
+echo "Analyzing testsuite..."
+for file in testsuite.* ; do
+    echo -n "$file ===> " && python ../pdlanalyzer/pdlanalyzer.py "$file" ;
+done    
Index: pkpgcounter/trunk/MANIFEST.in
===================================================================
--- pkpgcounter/trunk/MANIFEST.in (revision 197)
+++ pkpgcounter/trunk/MANIFEST.in (revision 197)
@@ -0,0 +1,3 @@
+include README FAQ COPYING BUGS TODO NEWS CREDITS MANIFEST.in clean.sh bin/pkpgcounter
+recursive-include man README *.sh *.1
+recursive-include tests README *.ps.gz *.sh
Index: pkpgcounter/trunk/clean.sh
===================================================================
--- pkpgcounter/trunk/clean.sh (revision 197)
+++ pkpgcounter/trunk/clean.sh (revision 197)
@@ -0,0 +1,28 @@
+#! /bin/sh
+#
+# pkpgcounter : a generic Page Description Language parser
+#
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+#
+# $Id$
+
+# Use this to clean the tree from temporary files
+
+find . -name "*.bak" -exec rm -f {} \;
+find . -name "*~" -exec rm -f {} \;
+find . -name "*.pyc" -exec rm -f {} \;
+find . -name "*.pyo" -exec rm -f {} \;
+find . -name "*.jem" -exec rm -f {} \;