Index: /pkpgcounter/trunk/BUGS
===================================================================
--- /pkpgcounter/trunk/BUGS (revision 187)
+++ /pkpgcounter/trunk/BUGS (revision 211)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -16,5 +16,5 @@
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 =============================================================================
Index: /pkpgcounter/trunk/tests/README
===================================================================
--- /pkpgcounter/trunk/tests/README (revision 197)
+++ /pkpgcounter/trunk/tests/README (revision 211)
@@ -16,5 +16,5 @@
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 ====================================================================
Index: /pkpgcounter/trunk/pdlanalyzer/pdf.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/pdf.py (revision 208)
+++ /pkpgcounter/trunk/pdlanalyzer/pdf.py (revision 211)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,5 +17,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/pdlanalyzer/pcl345.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/pcl345.py (revision 210)
+++ /pkpgcounter/trunk/pdlanalyzer/pcl345.py (revision 211)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,5 +17,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/pdlanalyzer/postscript.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/postscript.py (revision 208)
+++ /pkpgcounter/trunk/pdlanalyzer/postscript.py (revision 211)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,5 +17,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/pdlanalyzer/escp2.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/escp2.py (revision 200)
+++ /pkpgcounter/trunk/pdlanalyzer/escp2.py (revision 211)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,5 +17,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/pdlanalyzer/pdlparser.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/pdlparser.py (revision 200)
+++ /pkpgcounter/trunk/pdlanalyzer/pdlparser.py (revision 211)
@@ -2,5 +2,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,5 +15,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/pdlanalyzer/__init__.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/__init__.py (revision 190)
+++ /pkpgcounter/trunk/pdlanalyzer/__init__.py (revision 211)
@@ -2,5 +2,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,5 +15,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/pdlanalyzer/pclxl.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/pclxl.py (revision 207)
+++ /pkpgcounter/trunk/pdlanalyzer/pclxl.py (revision 211)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,5 +17,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/pdlanalyzer/analyzer.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/analyzer.py (revision 209)
+++ /pkpgcounter/trunk/pdlanalyzer/analyzer.py (revision 211)
@@ -2,5 +2,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,5 +15,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/pdlanalyzer/version.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/version.py (revision 190)
+++ /pkpgcounter/trunk/pdlanalyzer/version.py (revision 211)
@@ -2,5 +2,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,10 +15,10 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
 #
 
-__version__ = "1.10"
+__version__ = "1.50"
 
 __doc__ = """pkpgcounter : a generic Page Description Languages parser."""
Index: /pkpgcounter/trunk/setup.py
===================================================================
--- /pkpgcounter/trunk/setup.py (revision 199)
+++ /pkpgcounter/trunk/setup.py (revision 211)
@@ -17,5 +17,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/COPYING
===================================================================
--- /pkpgcounter/trunk/COPYING (revision 187)
+++ /pkpgcounter/trunk/COPYING (revision 211)
@@ -1,12 +1,11 @@
-                    GNU GENERAL PUBLIC LICENSE
-                       Version 2, June 1991
+		    GNU GENERAL PUBLIC LICENSE
+		       Version 2, June 1991
 
  Copyright (C) 1989, 1991 Free Software Foundation, Inc.
-                          59 Temple Place, Suite 330
-                          Boston, MA 02111-1307, USA.
+                       51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  Everyone is permitted to copy and distribute verbatim copies
  of this license document, but changing it is not allowed.
 
-                            Preamble
+			    Preamble
 
   The licenses for most software are designed to take away your
@@ -57,6 +56,6 @@
   The precise terms and conditions for copying, distribution and
 modification follow.
-
-                    GNU GENERAL PUBLIC LICENSE
+
+		    GNU GENERAL PUBLIC LICENSE
    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 
@@ -112,5 +111,5 @@
     does not normally print such an announcement, your work based on
     the Program is not required to print an announcement.)
-
+
 These requirements apply to the modified work as a whole.  If
 identifiable sections of that work are not derived from the Program,
@@ -170,5 +169,5 @@
 distribution of the source code, even though third parties are not
 compelled to copy the source along with the object code.
-
+
   4. You may not copy, modify, sublicense, or distribute the Program
 except as expressly provided under this License.  Any attempt
@@ -227,5 +226,5 @@
 This section is intended to make thoroughly clear what is believed to
 be a consequence of the rest of this License.
-
+
   8. If the distribution and/or use of the Program is restricted in
 certain countries either by patents or by copyrighted interfaces, the
@@ -257,5 +256,5 @@
 of promoting the sharing and reuse of software generally.
 
-                            NO WARRANTY
+			    NO WARRANTY
 
   11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
@@ -279,7 +278,7 @@
 POSSIBILITY OF SUCH DAMAGES.
 
-                     END OF TERMS AND CONDITIONS
-
-        Appendix: How to Apply These Terms to Your New Programs
+		     END OF TERMS AND CONDITIONS
+
+	    How to Apply These Terms to Your New Programs
 
   If you develop a new program, and you want it to be of the greatest
@@ -293,5 +292,5 @@
 
     <one line to give the program's name and a brief idea of what it does.>
-    Copyright (C) 19yy  <name of author>
+    Copyright (C) <year>  <name of author>
 
     This program is free software; you can redistribute it and/or modify
@@ -307,5 +306,6 @@
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
-    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
 
 Also add information on how to contact you by electronic and paper mail.
@@ -314,5 +314,5 @@
 when it starts in an interactive mode:
 
-    Gnomovision version 69, Copyright (C) 19yy name of author
+    Gnomovision version 69, Copyright (C) year name of author
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
     This is free software, and you are welcome to redistribute it
Index: /pkpgcounter/trunk/bin/pkpgcounter
===================================================================
--- /pkpgcounter/trunk/bin/pkpgcounter (revision 202)
+++ /pkpgcounter/trunk/bin/pkpgcounter (revision 211)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003,2004,2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,7 +23,14 @@
 #
 
+import sys
+from pdlanalyzer.version import __version__
 from pdlanalyzer import analyzer
 
 if __name__ == "__main__" : 
-    analyzer.main()
+    if (len(sys.argv) >= 2) and (sys.argv[1] in ("-h", "--help")) :
+        print "usage :  pkpgcounter  file1  [ file2  ... fileN [ <anotherfile ] ]"
+    elif (len(sys.argv) >= 2) and (sys.argv[1] in ("-v", "--version") :
+        print __version__
+    else :    
+        analyzer.main()
 
Index: /pkpgcounter/trunk/clean.sh
===================================================================
--- /pkpgcounter/trunk/clean.sh (revision 197)
+++ /pkpgcounter/trunk/clean.sh (revision 211)
@@ -16,5 +16,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: /pkpgcounter/trunk/NEWS
===================================================================
--- /pkpgcounter/trunk/NEWS (revision 187)
+++ /pkpgcounter/trunk/NEWS (revision 211)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -16,5 +16,5 @@
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 =============================================================================
@@ -22,4 +22,12 @@
 pkpgcounter News :
    
+  * 1.50 :
+  
+    - Major code changes to modularize. The pkpgcounter command line tool
+      is now just an almost empty skeleton, which uses the pdlanalyzer
+      library.
+      
+    - Several improvements to the parsing code.  
+      
   * 1.00 :
 
Index: /pkpgcounter/trunk/CREDITS
===================================================================
--- /pkpgcounter/trunk/CREDITS (revision 187)
+++ /pkpgcounter/trunk/CREDITS (revision 211)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -16,5 +16,5 @@
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 ============================================================
Index: /pkpgcounter/trunk/README
===================================================================
--- /pkpgcounter/trunk/README (revision 204)
+++ /pkpgcounter/trunk/README (revision 211)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -16,5 +16,5 @@
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 =============================================================================