Index: /pkpgcounter/trunk/pdlanalyzer/version.py
===================================================================
--- /pkpgcounter/trunk/pdlanalyzer/version.py (revision 220)
+++ /pkpgcounter/trunk/pdlanalyzer/version.py (revision 223)
@@ -20,8 +20,24 @@
 #
 
-__version__ = "1.53"
+__version__ = "1.54"
 
 __doc__ = """pkpgcounter : a generic Page Description Languages parser."""
 
-__author__ = """Jerome Alet - alet@librelogiciel.com"""
+__author__ = "Jerome Alet"
+__authoremail__ = "alet@librelogiciel.com"
+__years__ = "2003, 2004, 2005"
 
+__gplblurb__ = """This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA."""
+
Index: /pkpgcounter/trunk/bin/pkpgcounter
===================================================================
--- /pkpgcounter/trunk/bin/pkpgcounter (revision 222)
+++ /pkpgcounter/trunk/bin/pkpgcounter (revision 223)
@@ -24,10 +24,50 @@
 
 import sys
-from pdlanalyzer.version import __version__
+from pdlanalyzer.version import __version__, __author__, __authoremail__, \
+                                __years__, __gplblurb__
 from pdlanalyzer import analyzer
+
+__doc__ = """pkpgcounter v%(__version__)s (c) %(__years__)s %(__author__)s
+
+pkpgcounter is a generic Page Description Language parser.
+
+pkpgcounter parses any number of input files and/or its standard input
+and outputs the number of pages needed to print these documents.
+
+pkpgcounter currently recognizes the following document formats :
+
+    * PostScript (both DSC compliant and binary)
+    * PDF   
+    * PCLXL (aka PCL6)
+    * PCL3/4/5 (mostly)
+    * DVI
+    * TIFF
+    * ESC/P2
+
+command line usage :
+
+  pkpgcounter [options] [files]
+
+options :
+
+  -v | --version       Prints pkpgcounter's version number then exits.
+  -h | --help          Prints this message then exits.
+  
+  -d | --debug         Activate debug mode. 
+  
+examples :                              
+
+  $ pkpgcounter file1.ps file2.escp2 file3.pclxl <file4.pcl345
+  
+  Will launch pkpgcounter and will output the total number of pages
+  needed to print all the documents specified.
+  
+%(__gplblurb__)s  
+
+Please e-mail bugs to: %(__authoremail__)s"""
 
 if __name__ == "__main__" : 
     if (len(sys.argv) >= 2) and (sys.argv[1] in ("-h", "--help")) :
-        print "usage :  pkpgcounter  file1  [ file2  ... fileN [ <anotherfile ] ]"
+        print __doc__ % globals()
     elif (len(sys.argv) >= 2) and (sys.argv[1] in ("-v", "--version")) :
         print __version__
Index: /pkpgcounter/trunk/man/pkpgcounter.1
===================================================================
--- /pkpgcounter/trunk/man/pkpgcounter.1 (revision 223)
+++ /pkpgcounter/trunk/man/pkpgcounter.1 (revision 223)
@@ -0,0 +1,59 @@
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.35.
+.TH PKPGCOUNTER "1" "July 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.SH NAME
+pkpgcounter \- manual page for pkpgcounter 1.54
+.SH DESCRIPTION
+pkpgcounter v1.54 (c) 2003, 2004, 2005 Jerome Alet
+.PP
+pkpgcounter is a generic Page Description Language parser.
+.PP
+pkpgcounter parses any number of input files and/or its standard input
+and outputs the number of pages needed to print these documents.
+.PP
+pkpgcounter currently recognizes the following document formats :
+.IP
+* PostScript (both DSC compliant and binary)
+* PDF
+* PCLXL (aka PCL6)
+* PCL3/4/5 (mostly)
+* DVI
+* TIFF
+* ESC/P2
+.PP
+command line usage :
+.IP
+pkpgcounter [options] [files]
+.PP
+options :
+.TP
+\fB\-v\fR | \fB\-\-version\fR
+Prints pkpgcounter's version number then exits.
+.TP
+\fB\-h\fR | \fB\-\-help\fR
+Prints this message then exits.
+.TP
+\fB\-d\fR | \fB\-\-debug\fR
+Activate debug mode.
+.PP
+examples :
+.IP
+\f(CW$ pkpgcounter file1.ps file2.escp2 file3.pclxl <file4.pcl345\fR
+.IP
+Will launch pkpgcounter and will output the total number of pages
+needed to print all the documents specified.
+.PP
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+.PP
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+.PP
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110\-1301, USA.
+.PP
+Please e\-mail bugs to: alet@librelogiciel.com
Index: /pkpgcounter/trunk/man/genman.sh
===================================================================
--- /pkpgcounter/trunk/man/genman.sh (revision 223)
+++ /pkpgcounter/trunk/man/genman.sh (revision 223)
@@ -0,0 +1,20 @@
+#! /bin/sh
+#
+# pkpgcounter : a generic Page Description Language parser.
+#
+# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# You're welcome to redistribute this software under the
+# terms of the GNU General Public Licence version 2.0
+# or, at your option, any higher version.
+#
+# You can read the complete GNU GPL in the file COPYING
+# which should come along with this software, or visit
+# the Free Software Foundation's WEB site http://www.fsf.org
+#
+# $Id$
+#
+for prog in pkpgcounter ; do 
+    echo $prog ;
+    help2man --no-info --section=1 --manual "User Commands" --source="C@LL - Conseil Internet & Logiciels Libres" --output=$prog.1 $prog ; 
+    echo ;
+done